function EU = EU_MAX(w,a,M1,M2,M3,M4,ShortSell)

w = [w;1-sum(w)];
if (ShortSell == 0) && (any(w < 0) || any(w > 1))
    EU = -inf;
    return
end


M1p = w' * M1;
M2p = w' * M2 * w;
M3p = w' * M3 * kron(w,w);
M4p = w' * M4 * kron(kron(w,w),w);
EU = - 1/a * exp(-a*M1p) * (1 + 0.5*a^2*M2p - 1/6*a^3*M3p + 1/24*a^4*M4p);

