function [Wp,Vp,W_mv,R_mv,V_mv]=MV_FRONT(mu,sigma,Rp)



[dim,dim_test]=size(mu);
if dim==1 && dim_test>1
    mu=mu';
    dim=dim_test;
end

[ngrid_test,ngrid]=size(Rp);
if ngrid_test>1 && ngrid==1
    Rp=Rp';
    ngrid=ngrid_test;
end


inv_sigma=inv(sigma);
kesi=mu'*inv_sigma * mu;
alpha=ones(1,dim) * inv_sigma * mu;
delta=ones(1,dim) * inv_sigma * ones(dim,1);


upper_temp=kesi*inv_sigma*ones(dim,1)-alpha*inv_sigma*mu;
upper=upper_temp(:,ones(ngrid,1))+(delta*inv_sigma*mu-alpha*inv_sigma*ones(dim,1))*Rp;
lower=kesi*delta-alpha^2;
Wp=upper/lower;


Vp=(delta*Rp.^2-2*alpha*Rp+kesi)/lower;


R_mv=alpha/delta;
V_mv=1/delta;
W_mv=1/delta*inv_sigma*ones(dim,1);